#include<bits\stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin>>n>>q;
    int a[n], e[q];
    for(int i = 0; i < n; i++)
    {
        cin>>a[i];
    }
    for(int i = 0; i < q; i++)
    {
        int l, r;
        cin>>l>>r;
        l -= 1;
        r -= 1;
        e[i] = a[l];
        for(int j = l + 1; j <= r; j++)
        {
            e[i] = e[i] & a[j];
            if(e[i] == 0)
            {
                j = r + 1;
            }
        }
    }
    for(int i = 0; i < q; i++)
    {
        cout<<e[i]<<endl;
    }
}